#include<bits/stdc++.h>
#define st first
#define nd second
using namespace std;
typedef long long ll;

const int M = (1<<18), N = 2e5 + 10, mod = 1e9 + 7, K = 19;
int tree[M*2 + 10];
int lazy[M*2 + 10], n, t[N], tab[K][N];

void propagate(int node, int start, int end) {
    if (lazy[node] == 0) return;
    tree[node] = ((ll)lazy[node] * (ll)(end-start +1)) % mod;
    if (start != end) {
        lazy[node*2] = lazy[node];
        lazy[node*2+1] = lazy[node];
    }
    lazy[node] = 0;
}

void update(int l, int r, int val, int node = 1, int start = 0, int end = M-1) {
    propagate(node, start, end);
    if (l > end || start > r || start > end) return;

    if (start >= l && r >= end) {
        tree[node] = ((ll)val * (ll)(end - start + 1)) % mod;
        if (start != end) {
            lazy[node*2] = val;
            lazy[node*2 + 1] = val;
        }
        return;
    }

    int mid = (start + end)/2;
    update(l, r, val, node*2, start, mid);
    update(l, r, val, node*2+1, mid+1, end);

    tree[node] = (tree[node*2] + tree[node*2+1]);
    if (tree[node] >= mod) tree[node] -= mod;
}

int query(int l, int r, int node = 1, int start = 0, int end = M-1) {
    propagate(node,start,end);
    if (start > end || l > end || start > r) return 0;
    if (l <= start && end <= r) {
        return tree[node];
    }
    int mid = (start+end)/2;

    int p1 = query(l, r, node*2, start, mid);
    int p2 = query(l, r, node*2 + 1, mid+1, end);
    p1 += p2;
    return (p1 >= mod ? p1-mod : p1);
}

set<int> s, s1;

void genSparse() {
    for (int i = 0 ; i < n; ++i) tab[0][i] = t[i];

    for (int k = 1; k < K; ++k) {
        int pot = (1<<(k-1));
        for (int i = 0; i < n; ++i) {
            tab[k][i] = (i + pot >= n ? 0 :  __gcd(tab[k-1][i], tab[k-1][i + pot]));
        }
    }
}

int zap(int l, int r) {
    int k = (r - l + 1);
    int p = 0;
    while ((1<<p) <= k) {
        ++p;
    }
    --p;
    return __gcd(tab[p][l], tab[p][r-(1<<p)+1]);
}

int main() {
    ios_base::sync_with_stdio(false);
    cin >> n;
    for (int i = 0; i < n; ++i) {
        cin >> t[i];
    }
    genSparse();
    int ans = 0;
    stack<pair<int,int>> roz;
    for (int i = 0; i < n; ++i) {
        while (!roz.empty() && roz.top().st < t[i]) {
            roz.pop();
        }
        if (!roz.empty()) {
            update(roz.top().nd + 1, i, t[i]);
        } else {
            update(0, i, t[i]);
        }

        roz.push({t[i], i});
        
        for (auto c : s) {
            s1.insert(__gcd(c, t[i]));
        }
        
        s1.insert(t[i]);
        s = s1;
        s1.clear();
        
        int r = i;
        for (auto it = s.rbegin(); it != s.rend(); it++) {
            int cur = *it;

            int pocz = 0, kon = r;
            while (pocz < kon) {
                int mid = (pocz+kon) / 2;
                if (zap(mid, i) == cur) {
                    kon = mid-1;
                }else {
                    pocz = mid + 1;
                }
            }
            if (zap(pocz, i) != cur) pocz++; 
            if (pocz > 0 && zap(pocz-1, i) == cur) pocz--;


            ans += ((ll)query(pocz, r) * (ll)cur) % mod;
            ans %= mod;
            r = pocz - 1;
        }
    }
    cout << ans << "\n";
}